# MPI_Pack

Packs a datatype into contiguous memory

## Synopsis

    int MPI_Pack(const void *inbuf,
                 int incount,
                 MPI_Datatype datatype,
                 void *outbuf,
                 int outsize,
                 int *position,
                 MPI_Comm comm)

## Input Parameters

inbuf
  input buffer start (choice)
incount
  number of input data items (non-negative integer)
datatype
  datatype of each input data item (handle)
outsize
  output buffer size, in bytes (non-negative integer)
comm
  communicator for packed message (handle)

## Output Parameters

outbuf
  output buffer start (choice)

## Input/Output Parameters

position
  current position in buffer, in bytes (integer)

## Notes (from the specifications)

The input value of position is the first location in the output buffer to be used for packing. position is incremented by the size of the packed message, and the output value of position is the first location in the output buffer following the locations occupied by the packed message. The comm argument is the communicator that will be subsequently used for sending the packed message.

## Notes for Fortran

All MPI routines in Fortran (except for `MPI_WTIME` and `MPI_WTICK`) have an additional argument `ierr` at the end of the argument list. `ierr` is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the `call` statement.

All MPI objects (e.g., `MPI_Datatype`, `MPI_Comm`) are of type `INTEGER` in Fortran.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Comm_set_errhandler` (for communicators), `MPI_File_set_errhandler` (for files), and `MPI_Win_set_errhandler` (for RMA windows). The MPI-1 routine `MPI_Errhandler_set` may be used but its use is deprecated. The predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarentee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
  No error; MPI routine completed successfully.

MPI_ERR_ARG
  Invalid argument. Some argument is invalid and is not identified by a specific error class (e.g., `MPI_ERR_RANK`).

MPI_ERR_OTHER
  Other error; use `MPI_Error_string` to get more information about this error code.